# this is where we write a Forth-like interpreter for Hnsm.
# For non-forthers, that's our libc and so on.

GOELPT ()  # greater or equal lowest power of two
{
    let foo=1
    while test $foo -lt $1; do
        let foo*=2
    done
    echo $foo
}

# Hnsm is largely about supersetting Forth just a bit. Forth performed 
# miracles in tiny memories. The reason people still read 
# comp.lang.forth is it still is the best thing going in a world of 
# practically infinite RAM.

# An example of this that intrigues me is the Forth word header. Lets 
# give it at least 8 quads of metadata. OK, sixteen while we're at it. 
# If its a defined general purpose type, thats a lot of reuseablity. 
# The GForth docs lament their inability to come up with reuseable 
# array words. Lets have a go at 'segments', a C struct if you will of 
# 16 quads between two byte arrays.

# I'm fond of ring buffers. My thoughts on the most useful fields for a 
# segment are pointers east, west, and south, length, cursor, namelen, 
# and type. namelen is byte f. length is byte 0. Type 0 is hereby 
# reserved for Hnsm machine code.


NAME () ( # assemble a word name, a 0 pad to quads, and the name length.
	# the pad is just for hexdump legibility I guess
	na=$1
	let nb=${#na}
	let nc=\(3+$nb\)\>\>2
	let nd=\(nc*4\)-nb
	V $1				# wants to be a pad word
	if test $nd -eq 1 ; then V z ; fi
	if test $nd -eq 2 ; then V zz ; fi
	if test $nd -eq 3 ; then V zzz ; fi
	LITLEAQ $nb
echo $nb $nc $nd
)

